/*
 * Copyright (C) 1999 FSM Labs (http://www.fsmlabs.com/)
 *  Written by Cort Dougan <cort@fsmlabs.com>
 *
 */
#ifndef __ARCH_RTL_SYNC__
#define __ARCH_RTL_SYNC__

#include <asm/hw_irq.h>

extern struct int_control_struct rtl_hard_int_control;

#define rtl_hard_cli() rtl_hard_int_control.int_cli()
#define rtl_hard_sti() rtl_hard_int_control.int_sti()
#define rtl_hard_save_flags(x) rtl_hard_int_control.int_save_flags(&(x))
#define rtl_hard_restore_flags(x) rtl_hard_int_control.int_restore_flags(x)
#define rtl_hard_savef_and_cli(x) { rtl_hard_save_flags(x); rtl_hard_cli(); }
#define	rtl_no_interrupts(s) \
	({ rtl_hard_int_control.int_save_flags((unsigned long *)&s); rtl_hard_int_control.int_cli(); })
#define	rtl_restore_interrupts(s) rtl_hard_int_control.int_restore_flags(s)
#define	rtl_stop_interrupts() rtl_hard_int_control.int_cli()
#define	rtl_allow_interrupts() rtl_hard_int_control.int_sti()
#endif
