/*
 * Copyright (C) 1999 FSM Labs (http://www.fsmlabs.com/)
 *  Written by Cort Dougan <cort@fsmlabs.com>
 *  and Victor Yodaiken <yodaiken@fsmlabs.com>
 */
#ifndef __ARCH_RTL_SYNC__
#define __ARCH_RTL_SYNC__

#define	rtl_no_interrupts(s) \
__asm__ __volatile__("pushfl ; popl %0; cli":"=g" (s): /* no input */ :"memory")

#define	 rtl_restore_interrupts(s)\
__asm__ __volatile__("pushl %0 ; popfl": /* no output */ :"g" (s):"memory")

#define	 rtl_stop_interrupts()\
__asm__ __volatile__("cli": /* no output,no input */ ::"memory")

#define	 rtl_allow_interrupts() \
__asm__ __volatile__("sti": /* no output,no input */ :: "memory")


#define rtl_hard_savef_and_cli(x) rtl_no_interrupts(x)

#endif

